package ch.usi.inf.sa4.sanmarinoes.smarthut.service;

import ch.usi.inf.sa4.sanmarinoes.smarthut.models.*;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class AutomationService {
    private final AutomationRepository automationRepository;
    private final TriggerRepository<Trigger<?>> triggerRepository;
    private final ConditionRepository<Condition<?>> conditionRepository;

    @Autowired
    public AutomationService(
            AutomationRepository automationRepository,
            TriggerRepository<Trigger<?>> triggerRepository,
            ConditionRepository<Condition<?>> conditionRepository) {
        this.automationRepository = automationRepository;
        this.triggerRepository = triggerRepository;
        this.conditionRepository = conditionRepository;
    }

    public void findTriggersByDeviceId(Long deviceId, List<Trigger<?>> toPut) {
        toPut.addAll(triggerRepository.findAllByDeviceId(deviceId));
    }

    public Automation findByVerifiedId(Long automationId) {
        return automationRepository.findById(automationId).orElseThrow();
    }

    public void findAllConditionsByAutomationId(Long automationId, List<Condition<?>> toPut) {
        toPut.addAll(conditionRepository.findAllByAutomationId(automationId));
    }
}
