package ch.usi.inf.sa4.sanmarinoes.smarthut.config;

import static org.assertj.core.api.AssertionsForClassTypes.assertThat;
import static org.mockito.Mockito.when;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.test.util.ReflectionTestUtils;

@ExtendWith({MockitoExtension.class})
public class JWTTokenUtilsTests {
    @InjectMocks private JWTTokenUtils utils;

    @Mock private UserDetails userDetails;

    @Test
    public void testGenerateToken() {
        ReflectionTestUtils.setField(
                utils,
                "secret",
                "One, seven, three, four, six, seven\n"
                        + "Three, two, one, four, seven, six, charlie, three\n"
                        + "Two, seven, eight, nine, seven, seven, seven\n"
                        + "Six, four, three, tango, seven, three, two, victor, seven\n"
                        + "Three, one, one, seven, eight, eight, eight, seven, three\n"
                        + "Two, four, seven, six, seven, eight, nine\n"
                        + "Seven, six, four, three, seven, six\n"
                        + "Lock");
        when(userDetails.getUsername()).thenReturn("username");
        String token = utils.generateToken(userDetails);
        assertThat(token).isNotNull();
        assertThat(utils.validateToken(token, userDetails)).isTrue();
        assertThat(utils.getUsernameFromToken(token)).isEqualTo("username");
    }
}
