package ch.usi.inf.sa4.sanmarinoes.smarthut.models;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

@DisplayName("Scene Priority Tests")
public class ScenePriorityTests {

    private ScenePriority scenePriority;

    @BeforeEach
    public void scenePriorityCreate() {
        this.scenePriority = new ScenePriority();
    }

    @Test
    @DisplayName("get and set automation id")
    public void getAndSetAutomationId() {
        scenePriority.setAutomationId(20L);

        assertEquals(20, scenePriority.getAutomationId());
    }

    @Test
    @DisplayName("get and set id")
    public void getAndSetId() {
        scenePriority.setId(20L);

        assertEquals(20, scenePriority.getId());
    }

    @Test
    @DisplayName("get and set scene id")
    public void getAndSetSceneId() {
        scenePriority.setSceneId(20L);

        assertEquals(20, scenePriority.getSceneId());
    }

    @Test
    @DisplayName("get and set priority")
    public void getAndSetPriority() {
        scenePriority.setPriority(20);

        assertEquals(20, scenePriority.getPriority());
    }

    @Test
    @DisplayName("get and set automation")
    public void getAndSetAutomation() {
        Automation a = new Automation();
        scenePriority.setAutomation(a);

        assertEquals(a, scenePriority.getAutomation());
    }

    @Test
    @DisplayName("get and set scene")
    public void getAndSetScene() {
        Scene s = new Scene();
        scenePriority.setScene(s);

        assertEquals(s, scenePriority.getScene());
    }

    @Test
    @DisplayName("get and set scene")
    public void testRemove() {
        Scene s = new Scene();
        scenePriority.setScene(s);
        scenePriority.setSceneId(20L);

        Automation a = new Automation();
        scenePriority.setAutomation(a);
        scenePriority.setAutomationId(20L);

        scenePriority.preRemove();

        assertNull(scenePriority.getAutomation());
        assertNull(scenePriority.getAutomationId());
        assertNull(scenePriority.getScene());
        assertNull(scenePriority.getSceneId());
    }
}
