package ch.usi.inf.sa4.sanmarinoes.smarthut.models;

import static org.junit.jupiter.api.Assertions.assertTrue;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

@DisplayName("Switchable State Tests")
public class SwitchableStateTests {

    private SwitchableState switchableState;

    @BeforeEach
    public void createSwitchableState() {
        switchableState = new SwitchableState();
        switchableState.setDevice(new RegularLight());
    }

    @Test
    @DisplayName("is on")
    public void isOn() {
        switchableState.setOn(true);

        assertTrue(switchableState.isOn());

        switchableState.apply();
        assertTrue(((Switchable) switchableState.getDevice()).isOn());

        assertTrue(switchableState.copy().isOn());
    }
}
