package ch.usi.inf.sa4.sanmarinoes.smarthut.scheduled;

import static org.junit.jupiter.api.Assertions.assertDoesNotThrow;
import static org.mockito.Mockito.*;

import ch.usi.inf.sa4.sanmarinoes.smarthut.models.SmartPlug;
import ch.usi.inf.sa4.sanmarinoes.smarthut.models.SmartPlugRepository;
import ch.usi.inf.sa4.sanmarinoes.smarthut.models.User;
import ch.usi.inf.sa4.sanmarinoes.smarthut.socket.SensorSocketEndpoint;
import java.util.List;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;

@ExtendWith(MockitoExtension.class)
public class UpdateTasksTests {

    @InjectMocks private UpdateTasks updateTasks;

    @Mock private SmartPlugRepository smartPlugRepository;

    @Mock private SensorSocketEndpoint sensorSocketEndpoint;

    @Test
    public void testSmartPlugConsumptionFakeUpdate() {
        final User u = new User();
        final SmartPlug s = new SmartPlug();
        s.setId(20L);
        doReturn(u).when(smartPlugRepository).findUser(20L);
        doNothing()
                .when(smartPlugRepository)
                .updateTotalConsumption(SmartPlug.AVERAGE_CONSUMPTION_KW);
        when(smartPlugRepository.findByOn(true)).thenReturn(List.of(s));
        doNothing().when(sensorSocketEndpoint).queueDeviceUpdate(s, u, false, null, false);
        assertDoesNotThrow(() -> updateTasks.smartPlugConsumptionFakeUpdate());
    }
}
