package ch.usi.inf.sa4.sanmarinoes.smarthut.service;

import static org.assertj.core.api.Assertions.assertThat;
import static org.assertj.core.api.Assertions.assertThatThrownBy;
import static org.mockito.Mockito.when;

import ch.usi.inf.sa4.sanmarinoes.smarthut.models.User;
import ch.usi.inf.sa4.sanmarinoes.smarthut.models.UserRepository;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;
import org.springframework.security.core.userdetails.UsernameNotFoundException;

@ExtendWith({MockitoExtension.class})
public class JWTUserDetailsServiceTests {

    @InjectMocks private JWTUserDetailsService jwtUserDetailsService;

    @Mock private UserRepository userRepository;

    @Test
    public void testLoadByUsername() {
        final User u = new User();
        u.setUsername("username");
        u.setPassword("password");
        when(userRepository.findByUsername("username")).thenReturn(u);
        assertThatThrownBy(() -> jwtUserDetailsService.loadUserByUsername("username"))
                .isInstanceOf(UsernameNotFoundException.class);
        u.setEnabled(true);
        assertThat(jwtUserDetailsService.loadUserByUsername("username")).isNotNull();
    }
}
